part of graphlib.alg;

//var topsort = require("./topsort");
//
//module.exports = isAcyclic;

/**
 * Given a [Digraph] [g] this function returns `true` if the graph has no
 * cycles and returns `false` if it does. This algorithm returns as soon as it
 * detects the first cycle.
 *
 * Use [findCycles] if you need the actual list of cycles in a graph.
 *
 *     var digraph = new Digraph();
 *     digraph.addNode(1);
 *     digraph.addNode(2);
 *     digraph.addNode(3);
 *     digraph.addEdge(null, 1, 2);
 *     digraph.addEdge(null, 2, 3);
 *
 *     alg.isAcyclic(digraph);
 *     // => true
 *
 *     digraph.addEdge(null, 3, 1);
 *     alg.isAcyclic(digraph);
 *     // => false
 */
bool isAcyclic(Digraph g) {
  try {
    topsort(g);
  } catch (e) {
    if (e is CycleException) return false;
    throw e;
  }
  return true;
}
