library graphlib.filter;
/**
 * The filters in the module can be used with [filterNodes].
 */

/**
 * Returns all nodes in the graph. Thus `subgraph` is identical in the
 * following code blocks:
 *
 *     var subgraph = graph.copy();
 *
 *     var subgraph = graph.filterNodes(filter.all());
 */
all() {
  return (_) { return true; };
}

/** Returns `true` only for [nodes] with ids in the `list`. */
nodesFromList(Iterable nodes) {
  var set = new Set.from(nodes);
  return (u) {
    return set.contains(u);
  };
}
