library graphlib;
/**
 * Graphlib is a Dart library that provides data structures for
 * undirected and directed multi-graphs along with algorithms that can
 * be used with them.
 *
 * There are currently four major graph types in graphlib:
 *  * [Graph] represents an undirected multigraph
 *  * [Digraph] represents a directed multigraph
 *  * [CGraph] represents a compound undirected multigraph
 *  * [CDigraph] represents a compound directed multigraph
 *
 * Multigraphs are graphs that can contain more than one edge between
 * the same two nodes.
 *
 * Compound graphs are graphs that can have nodes that act as parents
 * to, or containers of, other nodes.
 */

import 'dart:math' as Math;

import 'util.dart' as util;

part 'base_graph.dart';
part 'cdigraph.dart';
part 'cgraph.dart';
part 'compoundify.dart';
part 'digraph.dart';
part 'graph.dart';

const VERSION = '0.7.5-pre';
