part of graphlib.test;

abstractGraphTest(Graph makeGraph()) {

  abstractBaseGraphTest(makeGraph);

  var g;

  setUp(() {
    g = makeGraph();
  });

  group('asDirected', () {
    var g;

    setUp(() {
      g = new Graph();
      g.addNode(1);
      g.addNode(2);
      g.addNode(3);
      g.addNode(4);
      g.addEdge('A', 1, 2, 'A');
      g.addEdge('B', 2, 3, 'B');
      g.addEdge('C', 3, 4, 'C');
      g.addEdge('D', 4, 1, 'D');
      g.addEdge('E', 4, 2, 'E');
    });

    test('returns a directed graph', () {
      expect(g.asDirected().isDirected(), isTrue);
    });

    test('has the same nodes', () {
      expect(g.asDirected().nodes()..sort(), equals([1, 2, 3, 4]));
    });

    test('has double the size', () {
      expect(g.asDirected().size(), equals(10));
    });

    test('preserves edge labels', () {
      var dg = g.asDirected();
      expect(dg.edge(dg.outEdges(1, 2)[0]), equals('A'));
      expect(dg.edge(dg.outEdges(2, 1)[0]), equals('A'));
      expect(dg.edge(dg.outEdges(2, 3)[0]), equals('B'));
      expect(dg.edge(dg.outEdges(3, 2)[0]), equals('B'));
      expect(dg.edge(dg.outEdges(3, 4)[0]), equals('C'));
      expect(dg.edge(dg.outEdges(4, 3)[0]), equals('C'));
      expect(dg.edge(dg.outEdges(4, 1)[0]), equals('D'));
      expect(dg.edge(dg.outEdges(1, 4)[0]), equals('D'));
      expect(dg.edge(dg.outEdges(4, 2)[0]), equals('E'));
      expect(dg.edge(dg.outEdges(2, 4)[0]), equals('E'));
    });
  });

  group('isDirected', () {
    test('always returns false', () {
      expect(new Graph().isDirected(), isFalse);
    });
  });
}
