part of graphlib.alg.test;

//var assert = require('../assert'),
//    Graph = require('../..').Graph,
//    Digraph = require('../..').Digraph,
//    components = require('../..').alg.components;

componentsTest() {
  group('alg.components', () {
    test('returns `[]` for an empty graph', () {
      expect(components(new Graph()), equals([]));
    });

    test('returns `[[a], [b]]` when `a` and `b` are not connected by a path', () {
      var graph = new Graph();
      graph.addNode('a');
      graph.addNode('b');
      expect(components(graph), equals([['a'], ['b']]));
    });

    test('returns `[[a, b]]` when `a` and `b` are connected', () {
      var graph = new Graph();
      graph.addNode('a');
      graph.addNode('b');
      graph.addEdge(null, 'a', 'b');
      expect(components(graph), equals([['a', 'b']]));
    });

    test('returns `[[a, b, c]]` for a graph `a -> b -> c`', () {
      var graph = new Graph();
      graph.addNode('a');
      graph.addNode('b');
      graph.addNode('c');
      graph.addEdge(null, 'a', 'b');
      graph.addEdge(null, 'b', 'c');
      expect(components(graph), equals([['a', 'b', 'c']]));
    });

    test('works for directed graphs', () {
      var graph = new Digraph();
      graph.addNode('a');
      graph.addNode('b');
      graph.addNode('c');
      graph.addEdge(null, 'a', 'b');
      // TODO: this needs to be made order insensitive...
      expect(components(graph), equals([['a', 'b'], ['c']]));
    });
  });
}