part of graphlib.alg.test;

//var assert = require('chai').assert,
//    Digraph = require('../..').Digraph,
//    Graph = require('../..').Graph,
//    findCycles = require('../..').alg.findCycles;

findCyclesTest() {
  group('alg.findCycles', () {
    test('returns an empty array for an empty graph', () {
      expect(findCycles(new Digraph()), equals([]));
    });

    test('returns an empty array if the graph has no cycles', () {
      var g = new Digraph();
      g.addNode(1);
      g.addNode(2);
      g.addNode(3);
      g.addEdge(null, 1, 2);
      g.addEdge(null, 2, 3);

      expect(sort(findCycles(g)), equals([]));
    });

    test('returns a single entry for a cycle of 1 edge', () {
      var g = new Digraph();
      g.addNode(1);
      g.addNode(2);
      g.addEdge(null, 1, 2);
      g.addEdge(null, 2, 1);

      expect(sort(findCycles(g)), equals([[1, 2]]));
    });

    test('returns a single entry for a triangle', () {
      var g = new Digraph();
      g.addNode(1);
      g.addNode(2);
      g.addNode(3);
      g.addEdge(null, 1, 2);
      g.addEdge(null, 2, 3);
      g.addEdge(null, 3, 1);

      expect(sort(findCycles(g)), equals([[1, 2, 3]]));
    });

    test('returns multiple entries for multiple cycles', () {
      var g = new Digraph();
      g.addNode(1);
      g.addNode(2);
      g.addNode(3);
      g.addNode(4);
      g.addNode(5);
      g.addNode(6);
      g.addEdge(null, 1, 2);
      g.addEdge(null, 2, 1);
      g.addEdge(null, 3, 4);
      g.addEdge(null, 4, 5);
      g.addEdge(null, 5, 3);

      expect(sort(findCycles(g)), equals([[1, 2], [3, 4, 5]]));
    });

//    test('throws an Error for undirected graphs', () {
//      expect(() { findCycles(new Graph()); }, throws);
//    });
  });
}
