part of graphlib.alg.test;

//var assert = require('../assert'),
//    Graph = require('../..').Graph,
//    Digraph = require('../..').Digraph,
//    preorder = require('../..').alg.preorder;

preorderTest() {
  group('alg.preorder', () {
    test('returns the root for a singleton graph', () {
      var g = new Graph();
      g.addNode(1);
      expect(collect_pre(g, 1), equals([1]));
    });

    test('works for an undirected tree', () {
      var g = new Graph();
      g.addNode(1);
      g.addNode(2);
      g.addNode(3);
      g.addNode(4);
      g.addNode(5);
      g.addEdge(null, 1, 2);
      g.addEdge(null, 1, 3);
      g.addEdge(null, 3, 4);
      g.addEdge(null, 3, 5);

      var result = collect_pre(g, 1);
      expect(result, unorderedEquals([1, 2, 3, 4, 5]));
      expect(result.length, equals(5));
      expect(result.indexOf(1) < result.indexOf(2), isTrue);
      expect(result.indexOf(1) < result.indexOf(3), isTrue);
      expect(result.indexOf(3) < result.indexOf(4), isTrue);
      expect(result.indexOf(3) < result.indexOf(5), isTrue);
    });

    test('fails for an undirected graph that is not a tree', () {
      var g = new Graph();
      g.addNode(1);
      g.addNode(2);
      g.addNode(3);
      g.addEdge(null, 1, 2);
      g.addEdge(null, 2, 3);
      g.addEdge(null, 3, 1);

      expect(() { collect_pre(g, 1); }, throws);
    });

    test('fails if root is not in the graph', () {
      var g = new Graph();
      g.addNode(1);
      expect(() { collect_pre(g, 2); }, throws);
    });

    test('fails if the graph is directed', () {
      var g = new Digraph();
      g.addNode(1);
      expect(() { collect_pre(g, 1); }, throws);
    });
  });
}

collect_pre(g, root) {
  var us = [];
  preorder(g, root, (u) { us.add(u); });
  return us;
}
