part of graphlib.alg.test;

//var assert = require('chai').assert,
//    Digraph = require('../..').Digraph,
//    Graph = require('../..').Graph,
//    topsort = require('../..').alg.topsort;

topsortTest() {
  group('alg.topsort', () {
    test('returns an empty array for an empty graph', () {
      expect(topsort(new Digraph()), equals([]));
    });

    test('sorts nodes such that earlier nodes have directed edges to later nodes', () {
      var g = new Digraph();
      g.addNode('a');
      g.addNode('b');
      g.addNode('c');
      g.addEdge(null, 'b', 'c');
      g.addEdge(null, 'c', 'a');
      expect(topsort(g), equals(['b', 'c', 'a']));
    });

    test('throws CycleException if there is a cycle', () {
      var g = new Digraph();
      g.addNode('a');
      g.addNode('b');
      g.addNode('c');
      g.addEdge(null, 'b', 'c');
      g.addEdge(null, 'c', 'a');
      g.addEdge(null, 'a', 'b');
      expect(() { topsort(g); }, throwsA(new isInstanceOf<CycleException>()));
    });

//    test('throws an error for undirected graphs', () {
//      expect(() { topsort(new Graph()); }, throws);
//    });
  });
}